# a nawk script
#
# caller must set xfield= on the command line

#   1      2     3       4        5             6
# Pattern CPFS IOPFS DISK_SORT RECORD_SIZE DISK_LAYOUT 
#  7              8      9    10     11         12     13
# FILE_BLOCKS BLOCK_SIZE Nio Ncomp NO_OF_DISKS total tthruput

function initnames()
{
    i = 0;

    patname[i++] =     "nullcommtest";
    patname[i++] =     "datacommtest";
    patname[i++] =     "memgettest";
    patname[i++] =     "copytest";
    patname[i++] =     "disktest";

    # plain patterns 
    patname[i++] =     "rrlw";
    patname[i++] =     "rrlps";
    patname[i++] =     "brlw";
    patname[i++] =     "rwlw";
    patname[i++] =     "bwlw";
    patname[i++] =     "wrlw";
    patname[i++] =     "wrlw1";
    patname[i++] =     "wwlw1";
    patname[i++] =     "wrseg";
    patname[i++] =     "wwseg";

    # Read, 1-D distributions 
    patname[i++] =     "wrn";
    patname[i++] =     "wrb";
    patname[i++] =     "wrc";

    # Read, 2-D DISTRIBUTION(NONE, ...) 
    patname[i++] =     "wrnn";
    patname[i++] =     "wrnb";
    patname[i++] =     "wrnc";

    # Read, 2-D DISTRIBUTION(BLOCK, ...) 
    patname[i++] =     "wrbn";
    patname[i++] =     "wrbb";
    patname[i++] =     "wrbc";

    # Read, 2-D DISTRIBUTION(CYCLIC, ...) 
    patname[i++] =     "wrcn";
    patname[i++] =     "wrcb";
    patname[i++] =     "wrcc";

    # Write, 1-D distributions 
    patname[i++] =     "wwn";
    patname[i++] =     "wwb";
    patname[i++] =     "wwc";

    # Write, 2-D DISTRIBUTION(NONE, ...) 
    patname[i++] =     "wwnn";
    patname[i++] =     "wwnb";
    patname[i++] =     "wwnc";

    # Write, 2-D DISTRIBUTION(BLOCK, ...) 
    patname[i++] =     "wwbn";
    patname[i++] =     "wwbb";
    patname[i++] =     "wwbc";

    # Write, 2-D DISTRIBUTION(CYCLIC, ...) 
    patname[i++] =     "wwcn";
    patname[i++] =     "wwcb";
    patname[i++] =     "wwcc";

    sortname[0] = "nosort";
    sortname[1] = "sort";

    i = 0;
    cpfsname[i++] = "none";
    cpfsname[i++] = "single";
    cpfsname[i++] = "double";
    cpfsname[i++] = "thread";
    cpfsname[i++] = "direct";

    i = 0;
    iopfsname[i++] = "none";
    iopfsname[i++] = "buffer";
    iopfsname[i++] = "cache";
    iopfsname[i++] = "direct";
    iopfsname[i++] = "general";

    layoutname[0] = "contig";
    layoutname[1] = "rsectors";
    layoutname[2] = "rtracks";
}

function max(a,b) { return (a < b ? a : b); }

BEGIN {
  initnames();
  maxPerDisk = 72 * 512 / 1024 * 4002 / 60; # KB/s
  maxPerBus = 10 * 1024; # KB/s
  datafilebase = "/tmp/dotrend/data"
  plotfile = "/tmp/dotrend/plot"
  maxfile = "/tmp/dotrend/max"
  print "set ylabel \"KB/s\"" >> plotfile;
  print "set xlabel \"field " xfield "\"" >> plotfile;
  print "set data style linespoints" >> plotfile;
}

# for every input line
{
  y=$13;
  if (patname[$1] == "wrlw") y /= $10; # scale by Ncomp

  config = iopfsname[$3] "." sortname[$4] "." layoutname[$6];
  pat = patname[$1];
  datafile = datafilebase "." config "." pat;
  print $xfield, y > datafile;

  if ( !($xfield in maxcurve)) {
#                       max(Ndisk * maxPerDisk, Nio * maxPerBus);
    maxcurve[$xfield] = max($11 * maxPerDisk, $9 * maxPerBus);
    print $xfield, maxcurve[$xfield] > maxfile;
  }

  configs[config] = 1;
  pats[pat] = 1;
  curves[config "." pat] = 1;
}

END {
  printf "plot '%s' w lines 6,", maxfile >> plotfile;

  linestyle = 0;
  for (config in configs) {
      linestyle++;

      pointstyle = 0;
      for (pat in pats) {
	  pointstyle++;
	  c = (config "." pat);
	  if ( !(c in curves)) continue;

	  datafile = datafilebase "." c;
	  printf ("\\\n '%s' title '%s' w linesp %d %d,", 
	    datafile, c, linestyle, pointstyle) >> plotfile;
      }
  }
  printf "0 notitle\n" >> plotfile;
}
